
mainfun=function(fam.geno, hapdata, hap.exp, hapdata1, hap.exp1)
{
if (nrow(hapdata)!=nrow(hapdata1)){
	cat("Number of haplotype parameters in H0 are different from H1")
}else if (nrow(hapdata)==nrow(hapdata1)){ 
n.hap=nrow(hapdata)    
n.col=ncol(hapdata)
n.loci=ncol(hapdata)-2 
sort.freq=sort(hapdata[,n.col], decreasing=T, method = "sh", index=TRUE) 
hapdata=hapdata[sort.freq$ix,]
cum.freq=cumsum(hapdata[,n.col])
hapdata=cbind(hapdata,cum.freq)  
hapdata1=hapdata1[sort.freq$ix,] 
cafreq=hapdata1[,n.loci+2]
cnfreq=hapdata1[,n.loci+3] 
##==================================================================================================
core.hap=hapdata[hapdata$cum.freq<0.9,] 
H1.core.hap=hapdata1[hapdata$cum.freq<0.9,] 
rare.hap=hapdata[-c(1:nrow(core.hap)),] 
H1.rare.hap=hapdata1[-c(1:nrow(core.hap)),] 
n.core=nrow(core.hap)
n.rare=nrow(rare.hap)
dis.core=matrix(0,n.rare,n.core)  
for (i in 1:n.rare){
 for (j in 1:n.core){
  dis.core[i,j]=sum(abs(rare.hap[i,1:n.loci]-core.hap[j,1:n.loci]))
 }
}
min.dis.core=apply(dis.core,1,min) 
B=(min.dis.core[1:n.rare]==dis.core[1:n.rare,]) 
B.core=ifelse(B=='TRUE',1,0) 
B.core.mother.no=apply(B.core,1,sum) 
##==================================================================================================
H.min=range(min.dis.core)[1] 
H.max=range(min.dis.core)[2]
H.f=factor(min.dis.core)
H.num=levels(H.f)
H.category=as.numeric(H.num)
H.n=length(H.category) 
HH=cbind(rare.hap,min.dis.core,H1.rare.hap[,n.loci+2],H1.rare.hap[,n.loci+3])
H=as.list(rep(0,H.max))
for (i in 1:H.n){
 H[[H.category[i]]]=HH[HH$min.dis.core==(H.category[i]),]
}
n.H=as.list(rep(0,H.max))
for (i in 1:H.n){
 n.H[[H.category[i]]]=nrow(H[[H.category[i]]])
}
##==================================================================================================
if (H.max>1)
{
	temp.nH=rep(0,(H.max-1))
	for (i in 1:(H.max-1))
	{
		temp.nH[i]=n.H[[i+1]]-n.H[[i]]
	}
	regen=any(temp.nH==0)
}else
{
	regen="FALSE"
}
##==================================================================================================
if (regen=="TRUE"){ 
	cat("There are more than two generations without haplotype")
}else if(regen!="TRUE"){
rare.core.length=cbind(rare.hap, B.core, min.dis.core, B.core.mother.no)
B.core.length=list() 
B.core.mother.no.length=list()
for (i in 1:H.max){
	B.core.length[[i]]=B.core[min.dis.core==i,]
	B.core.mother.no.length[[i]]=B.core.mother.no[min.dis.core==i] 
}
##==================================================================================================
B1.down.temp=list()
B1.down.rep=list()
B1.up.rep=list()
B1.up=list()
B1=as.list(rep(0,H.max)) 
for (i in 1:H.max){
	if (n.H[[i]]!=0){
	B1.down.temp[[i]]=B.core.length[[i]]%*%matrix(core.hap[,n.col],n.core,1)
	B1.down.rep[[i]]=B1.down.temp[[i]]%*%matrix(1,1,n.core)
	B1.up.rep[[i]]=matrix(1,n.H[[i]],1)%*%t(core.hap[,n.col])
	B1.up[[i]]=B1.up.rep[[i]]*B.core.length[[i]]
	B1[[i]]=B1.up[[i]]/B1.down.rep[[i]]
	}
}
##==================================================================================================
if (H.max>1){
dis.length=list() 
dis.layer=list() 
min.length=list()
min.layer=list()
B.eq.length=list()
B.eq.layer=list()
B.mother.no.layer=list()
B.mother.no=list()
B.eq.min=list()
B.layer=list()
B.num=list()

for (i in 1:(H.max-1)){
 dis.length[[i]]=as.list(rep(0,H.max-i))
 min.length[[i]]=as.list(rep(0,H.max-i))
 B.eq.min[[i]]=as.list(rep(0,H.max-i))
 B.eq.length[[i]]=as.list(rep(0,H.max-i))
 B.mother.no[[i]]=as.list(rep(0,H.max-i))
 	for (j in 1:(H.max-i)){
 		if (n.H[[j]]!=0 & n.H[[j+i]]!=0)  
 		{
 			dis.layer[[j]]=matrix(0,n.H[[j+i]],n.H[[j]])
 			B.eq.layer[[j]]=matrix(0,n.H[[j+i]],n.H[[j]])
 			B.mother.no.layer[[j]]=matrix(0,n.H[[j+i]],1)
 			B.layer[[j]]=matrix(0,n.H[[j+i]],n.H[[j]])
 			B.num[[j]]=matrix(0,n.H[[j+i]],n.H[[j]])
 			min.layer[[j]]=matrix(0,n.H[[j+i]],1)
 			
 				for (m in 1:n.H[[j+i]]){
 				for (n in 1:n.H[[j]]){
 		    	dis.layer[[j]][m,n]=sum(abs(H[[j+i]][m,1:n.loci]-H[[j]][n,1:n.loci]))
 		    	B.eq.layer[[j]][m,n]=ifelse(dis.layer[[j]][m,n]==i,1,0)
 		    }
 				}
 		     	B.mother.no.layer[[j]]=apply(B.eq.layer[[j]],1,sum)
 		     	min.layer[[j]]=apply(dis.layer[[j]],1,min)
 		    	B.layer[[j]]=(min.layer[[j]][1:n.H[[j+i]]]==dis.layer[[j]][1:n.H[[j+i]],])
 		    	B.layer[[j]]=matrix(B.layer[[j]],n.H[[j+i]],n.H[[j]])
 				for (m in 1:n.H[[j+i]]){
 				for (n in 1:n.H[[j]]){		
 		    	B.num[[j]][m,n]=ifelse(B.layer[[j]][m,n]=="TRUE",1,0)
 		    }
 		    }
 		     	dis.length[[i]][[j]]=dis.layer[[j]]
 		    	min.length[[i]][[j]]=min.layer[[j]]
 		    	B.eq.length[[i]][[j]]=B.eq.layer[[j]]
 		    	B.mother.no[[i]][[j]]=B.mother.no.layer[[j]]
 		    	B.eq.min[[i]][[j]]=B.num[[j]]
	 	} else
 		{
 			 dis.layer[[j]]=0
 			 min.layer[[j]]=0
 			 B.layer[[j]]=0
 			 B.num[[j]]=0
 			 B.eq.layer[[j]]=0
 			 B.mother.no.layer[[j]]=0
 			 dis.length[[i]][[j]]=dis.layer[[j]]
 		   min.length[[i]][[j]]=min.layer[[j]]
 		   B.eq.length[[i]][[j]]=B.eq.layer[[j]]
 		   B.mother.no[[i]][[j]]=B.mother.no.layer[[j]]
 		   B.eq.min[[i]][[j]]=B.num[[j]]
 		}   	
  }
}

B=list()
B.down.temp=list()
B.down.rep.temp=list()
B.up.rep.temp=list()
B.up.temp=list()
B.temp=list()

for (i in 1:(H.max-1)){
	B[[i]]=as.list(rep(0,H.max-i))		
		for (j in 1:(H.max-i)){			
			if (n.H[[j]]!=0 & n.H[[j+i]]!=0) 
			{ 
			B.down.temp[[j]]=matrix(0,n.H[[i+j]],1)
			B.down.rep.temp[[j]]=matrix(0,n.H[[i+j]],n.H[[j]])
			B.up.rep.temp[[j]]=matrix(0,n.H[[i+j]],n.H[[j]])
			B.up.temp[[j]]=matrix(0,n.H[[i+j]],n.H[[j]])
			B.temp[[j]]=matrix(0,n.H[[i+j]],n.H[[j]])

			B.down.temp[[j]]=B.eq.length[[i]][[j]]%*%matrix(H[[j]][,n.col],n.H[[j]],1)
			B.down.rep.temp[[j]]=B.down.temp[[j]]%*%matrix(1,1,n.H[[j]])
			B.up.rep.temp[[j]]=matrix(1,n.H[[i+j]],1)%*%t(H[[j]][,n.col])
			B.up.temp[[j]]=B.up.rep.temp[[j]]*B.eq.length[[i]][[j]]
			B.temp[[j]]=B.up.temp[[j]]/B.down.rep.temp[[j]] 
	    
	  	B[[i]][[j]]=B.temp[[j]]
	  	}
	  	else 
	  	{
	  	B[[i]][[j]]=matrix(0,1,1)
	  	
	  	}	  	
	} 
} 
}
##==================================================================================================
Bnew=as.list(rep(0,H.max))
	if (n.H[[1]]!=0)
		{Bnew[[1]]=B1[[1]]} 
			if (n.H[[1]]==0)
		{Bnew[[1]]=matrix(0,1,1)}

if (H.max>1){
 for (i in 2:H.max){
  if (n.H[[i]]!=0 & n.H[[i-1]]!=0) 
  {
	 temp=(min.length[[1]][[i-1]]!=1) 
	 B[[1]][[i-1]][temp,]=0  
	 Bnew[[i]]=B[[1]][[i-1]]
  }
 
  if (n.H[[i]]==0 | n.H[[i-1]]==0)
  {
	 Bnew[[i]]=matrix(0,1,1)
  } 
 }
}
##==================================================================================================
hapfreq=as.list(rep(0,H.max))
ca.hapfreq=as.list(rep(0,H.max)) 
cn.hapfreq=as.list(rep(0,H.max))

for (i in 1:H.max){
  if (n.H[[i]]!=0 ) 
  {
	hapfreq[[i]]=H[[i]][,n.col]
  ca.hapfreq[[i]]=H[[i]][,n.loci+5] 
  cn.hapfreq[[i]]=H[[i]][,n.loci+6]
  }
}
corefreq=core.hap[,n.col]
ca.corefreq=H1.core.hap[,n.loci+2]
cn.corefreq=H1.core.hap[,n.loci+3]
##==================================================================================================
if (H.max>1) 
{
	temp=as.list(rep(0,H.max))
	pseudo.col=as.list(rep(0,H.max))
	pseudo.no=as.list(rep(0,H.max))

 for (j in (H.max-1):1)
 {
  if (n.H[[1+j]]!=0 & n.H[[j]]!=0)
  { 
 	 pseudo.no[[1+j]]=rep(0, n.H[[1+j]])
	for (k in 1: n.H[[1+j]])
	{  
		if (min.length[[1]][[j]][k]!=1 & j>1) 
		{
			temp[[1+j]]=c(1:n.H[[1+j]])
			pseudo.col[[1+j]]=as.matrix(ifelse(temp[[1+j]]==k,1,0))
			Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]], rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ) )
			for (pn in 1:(j-1))
			{				
				if (is.na(min.length[[1+pn]][[j-pn]][k])=='FALSE' & min.length[[1+pn]][[j-pn]][k]==(1+pn)) 
				                                                                                    
				{pseudo.no[[1+j]][k]=pn}
				
				if (is.na(min.length[[1+pn]][[j-pn]][k])=='FALSE' & min.length[[1+pn]][[j-pn]][k]!=(1+pn) & pn==j-1)
				{pseudo.no[[1+j]][k]=pn+1}
				
				if (is.na(min.length[[1+pn]][[j-pn]][k])=='TRUE' & pn==j-1)
				{pseudo.no[[1+j]][k]=pn+1}
			}
			if (pseudo.no[[1+j]][k]!=0 & pseudo.no[[1+j]][k]!=1 )
			{
				for (c in 1: (pseudo.no[[1+j]][k]-1))
				{  
         if (n.H[[1+j-c]]!=0 & n.H[[j-c]]!=0  ) 
          { 			
					Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]])))
					hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
					ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
					cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
					Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1))
				 }
				 		 
				 if (n.H[[1+j-c]]!=0 & n.H[[j-c]]==0)
				 {
				 	if (ncol(Bnew[[1+j-c]])+nrow(Bnew[[1+j-c]])==2)
				 	{
				 		if (Bnew[[1+j-c]]==0)
				 		{
				    	Bnew[[1+j-c]]=matrix(0,n.H[[1+j-c]],1)
            	hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
					  	ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
					  	cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
				    	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],1)
				    } else
				    
				    {
				    	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]]))) 
						  hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
						  ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
						  cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
						  Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1)) 	
				    }
				    
				  } else
				  
				  {
				  	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]])))
						hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
						ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
						cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
						Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1)) 		  			  
				  }
				 }
				}
	  
				if (j-c!=1) 
				{
					if (n.H[[j-c]]!=0)
				  {
					  Bnew[[j-c]]=rbind(Bnew[[j-c]], c( B[[1+(c+1)]][[j-(c+1)]][k,], rep(0, ncol(Bnew[[j-c]])-n.H[[j-(c+1)]]) ) )
					  hapfreq[[j-c]]=c(hapfreq[[j-c]],0)
					  ca.hapfreq[[j-c]]=c(ca.hapfreq[[j-c]],0)
					  cn.hapfreq[[j-c]]=c(cn.hapfreq[[j-c]],0)
					}	else
					
					{
					  if (ncol(Bnew[[j-c]])+nrow(Bnew[[j-c]])==2)
					  {
						   if (Bnew[[j-c]]==0)
					     {
					       Bnew[[j-c]]=matrix(B[[1+(c+1)]][[j-(c+1)]][k,], 1, n.H[[j-(c+1)]])
					       hapfreq[[j-c]]=hapfreq[[j-c]]
					  		 ca.hapfreq[[j-c]]=ca.hapfreq[[j-c]]
					  		 cn.hapfreq[[j-c]]=cn.hapfreq[[j-c]]
 							 } else
							 
							 {
							   Bnew[[j-c]]=rbind(Bnew[[j-c]], c( B[[1+(c+1)]][[j-(c+1)]][k,], rep(0, ncol(Bnew[[j-c]])-n.H[[j-(c+1)]]) ) )
					     	 hapfreq[[j-c]]=c(hapfreq[[j-c]],0)
					  	   ca.hapfreq[[j-c]]=c(ca.hapfreq[[j-c]],0)
					  	   cn.hapfreq[[j-c]]=c(cn.hapfreq[[j-c]],0)
							 }
							 					 
						 } else
						 
						 {
						   Bnew[[j-c]]=rbind(Bnew[[j-c]], c( B[[1+(c+1)]][[j-(c+1)]][k,], rep(0, ncol(Bnew[[j-c]])-n.H[[j-(c+1)]]) ) )
					     hapfreq[[j-c]]=c(hapfreq[[j-c]],0)
					  	 ca.hapfreq[[j-c]]=c(ca.hapfreq[[j-c]],0)
					  	 cn.hapfreq[[j-c]]=c(cn.hapfreq[[j-c]],0)		 
						 }
					}

				}
				
				if (j-c==1 & n.H[[1]]!=0) 
				{
					Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] )
					hapfreq[[1]]=c(hapfreq[[1]],0)
					ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
					cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)
        } 
				
				if (j-c==1 & n.H[[1]]==0 )
				{
					if (ncol(Bnew[[1]])+nrow(Bnew[[1]])==2)
					{  
					  if (Bnew[[1]]==0)
					  {
					    Bnew[[1]]=matrix(B1[[1+j]][k,],1,n.core)
					    hapfreq[[1]]=c(hapfreq[[1]])        
					    ca.hapfreq[[1]]=c(ca.hapfreq[[1]])   
					    cn.hapfreq[[1]]=c(cn.hapfreq[[1]])
					  } else
					  {
					    Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] ) 
						  hapfreq[[1]]=c(hapfreq[[1]],0)
						  ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
						  cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)					  
					  }
					}	else 
					{
						Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] ) 
						hapfreq[[1]]=c(hapfreq[[1]],0)
						ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
						cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)
					}					
				} 
	  						
			}
	   if (pseudo.no[[1+j]][k]==1 ) 
		 {                                                  
				Bnew[[j]]=rbind(Bnew[[j]],c( B[[1+1]][[j-1]][k,], rep(0, ncol(Bnew[[j]])-n.H[[j-1]] ) ))  
				hapfreq[[j]]=c(hapfreq[[j]],0)
				ca.hapfreq[[j]]=c(ca.hapfreq[[j]],0)
				cn.hapfreq[[j]]=c(cn.hapfreq[[j]],0)
		  }
		}
		if (min.length[[1]][[j]][k]!=1 & j==1) 
		{                                      
			temp[[1+j]]=c(1:n.H[[1+j]])
			pseudo.col[[1+j]]=as.matrix(ifelse(temp[[1+j]]==k,1,0))
			Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]], rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ) )
			Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] )          
			hapfreq[[1]]=c(hapfreq[[1]],0)
			ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
			cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)
		 }
	 }
	}

	if (n.H[[j+1]]!=0 & n.H[[j]]==0) 
	{																  
	 pseudo.no[[1+j]]=rep(0, n.H[[1+j]])
	 for (k in 1: n.H[[1+j]])
	 {
		if (j==1) 
		{
			if (ncol(Bnew[[j+1]])+nrow(Bnew[[j+1]])==2) 
			{
				temp[[1+j]]=c(1:n.H[[1+j]])
				pseudo.col[[1+j]]=as.matrix(ifelse(temp[[1+j]]==k,1,0))
				if (Bnew[[j+1]]==0)
				{
		    	Bnew[[1+j]]=matrix(pseudo.col[[1+j]],n.H[[1+j]],1)
					Bnew[[1]]=B1[[1+j]][k,]
					hapfreq[[1]]=c(hapfreq[[1]])
					ca.hapfreq[[1]]=c(ca.hapfreq[[1]])
					cn.hapfreq[[1]]=c(cn.hapfreq[[1]])			
				}	else
				
				{
		    	Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]], rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ) )
					Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] )          
					hapfreq[[1]]=c(hapfreq[[1]],0)
					ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
					cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)	
				}
			}	else
			
			{
	    	temp[[1+j]]=c(1:n.H[[1+j]])
				pseudo.col[[1+j]]=as.matrix(ifelse(temp[[1+j]]==k,1,0))
	    	Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]], rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ) ) 
				Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] )          
				hapfreq[[1]]=c(hapfreq[[1]],0)
				ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
				cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)
			}
		}
		
		if (j!=1) 
		{
			temp[[1+j]]=c(1:n.H[[1+j]])
			pseudo.col[[1+j]]=as.matrix(ifelse(temp[[1+j]]==k,1,0))
		  if (min.length[[2]][[j-1]][k]==2)
		  {
				if (ncol(Bnew[[j+1]])+nrow(Bnew[[j+1]])==2)
				{
				  if (Bnew[[j+1]]==0)
				  {
  				  Bnew[[1+j]]=matrix(pseudo.col[[1+j]],n.H[[1+j]],1)
  				  hapfreq[[j]]=c(hapfreq[[j]])
  					ca.hapfreq[[j]]=c(ca.hapfreq[[j]])
  					cn.hapfreq[[j]]=c(cn.hapfreq[[j]])
  				  Bnew[[j]]=matrix(B[[2]][[j-1]][k,],1,n.H[[j-1]])
					} else
				  
				  {
  				  Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]],rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ))
  				  hapfreq[[j]]=c(hapfreq[[j]],0)
  					ca.hapfreq[[j]]=c(ca.hapfreq[[j]],0)
  					cn.hapfreq[[j]]=c(cn.hapfreq[[j]],0)
  				  Bnew[[j]]=rbind(Bnew[[j]], c( B[[2]][[j-1]][k,], rep(0, ncol(Bnew[[j]])-n.H[[j-1]])) )		  
				  }
				  
				}	else
				
				{
  				  Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]],rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ))
  				  hapfreq[[j]]=c(hapfreq[[j]],0)
  					ca.hapfreq[[j]]=c(ca.hapfreq[[j]],0)
  					cn.hapfreq[[j]]=c(cn.hapfreq[[j]],0)
  				  Bnew[[j]]=rbind(Bnew[[j]], c( B[[2]][[j-1]][k,], rep(0, ncol(Bnew[[j]])-n.H[[j-1]])) )		  			
				}
			}
	    
	    if (min.length[[2]][[j-1]][k]>2)
			{
				
				for (pn in 1:(j-1))
				{				
					if (is.na(min.length[[1+pn]][[j-pn]][k])=='FALSE' & min.length[[1+pn]][[j-pn]][k]==(1+pn))
				                                                                                           
					{pseudo.no[[1+j]][k]=pn}
					
					if (is.na(min.length[[1+pn]][[j-pn]][k])=='FALSE' & min.length[[1+pn]][[j-pn]][k]!=(1+pn) & pn==j-1) 
					{pseudo.no[[1+j]][k]=pn+1}
				
					if (is.na(min.length[[1+pn]][[j-pn]][k])=='TRUE' & pn==j-1) 
					{pseudo.no[[1+j]][k]=pn+1}					
				}
								
				if (ncol(Bnew[[j+1]])+nrow(Bnew[[j+1]])==2)
				{
					if (Bnew[[j+1]]==0)
					{
					  Bnew[[1+j]]=matrix(pseudo.col[[1+j]],n.H[[1+j]],1)
					} else
					
					{
					  Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]],rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ))
					}
				}	else
				
				{
					 Bnew[[1+j]]=cbind(Bnew[[1+j]],c(pseudo.col[[1+j]],rep(0, nrow(Bnew[[1+j]]) -n.H[[1+j]]) ))
				}

			if (pseudo.no[[1+j]][k]!=0 & pseudo.no[[1+j]][k]!=1 )
			{

				for (c in 1: (pseudo.no[[1+j]][k]-1))
				{            
         if (n.H[[1+j-c]]!=0 & n.H[[j-c]]!=0  ) 
         { 			
					Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]])))  
					hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
					ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
					cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
					Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1))
				 }
				 
  
				 if (n.H[[1+j-c]]!=0 & n.H[[j-c]]==0)
				 {
				 	if (ncol(Bnew[[1+j-c]])+nrow(Bnew[[1+j-c]])==2)
				 	{
				 		if (Bnew[[1+j-c]]==0)
				 		{
				    	Bnew[[1+j-c]]=matrix(0,n.H[[1+j-c]],1)
            	hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
					  	ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
					  	cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
				    	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],1)
				    } else
				    
				    {
				    	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]])))  
						  hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
						  ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
						  cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
						  Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1)) 	
				    }
				    
				  } else 
				  
				  {
				  	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]]))) 
						hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
						ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
						cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
						Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1)) 		  			  
				  }
				 }
  
   
				 if (n.H[[1+j-c]]==0 & n.H[[j-c]]!=0) 
				 {
				 	if (ncol(Bnew[[1+j-c]])+nrow(Bnew[[1+j-c]])==2)
				 	{
				 		if (Bnew[[1+j-c]]==0)
				 		{
				    	Bnew[[1+j-c]]=matrix(0,1,n.H[[1+j-c-1]])
            	hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]])
					  	ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]])
					  	cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]])
				    	Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],1)
				    }	else
				    
				    {
				    	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]]))) 
						  hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
						  ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
						  cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
						  Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1)) 	
				    }
				  }	else
				  
				  {
				  	Bnew[[1+j-c]]=rbind(Bnew[[1+j-c]],rep(0,ncol(Bnew[[1+j-c]])))  
						hapfreq[[1+j-c]]=c(hapfreq[[1+j-c]],0)
						ca.hapfreq[[1+j-c]]=c(ca.hapfreq[[1+j-c]],0)
						cn.hapfreq[[1+j-c]]=c(cn.hapfreq[[1+j-c]],0)
						Bnew[[1+j-c]]=cbind(Bnew[[1+j-c]],c(rep(0,nrow(Bnew[[1+j-c]])-1),1)) 		  			  
				  }
				 }
				}
	  
				if (j-c!=1) 
				{
					if (n.H[[j-c]]!=0)
				  {
					  Bnew[[j-c]]=rbind(Bnew[[j-c]], c( B[[1+(c+1)]][[j-(c+1)]][k,], rep(0, ncol(Bnew[[j-c]])-n.H[[j-(c+1)]]) ) )
					  hapfreq[[j-c]]=c(hapfreq[[j-c]],0)
					  ca.hapfreq[[j-c]]=c(ca.hapfreq[[j-c]],0)
					  cn.hapfreq[[j-c]]=c(cn.hapfreq[[j-c]],0)
					}	else
					
					{
					  if (ncol(Bnew[[j-c]])+nrow(Bnew[[j-c]])==2)
					  {
						   if (Bnew[[j-c]]==0)
					     {
					       Bnew[[j-c]]=matrix(B[[1+(c+1)]][[j-(c+1)]][k,], 1, n.H[[j-(c+1)]]) 
					       hapfreq[[j-c]]=hapfreq[[j-c]]
					  		 ca.hapfreq[[j-c]]=ca.hapfreq[[j-c]]
					  		 cn.hapfreq[[j-c]]=cn.hapfreq[[j-c]]
 							 } else 
							 
							 {
							   Bnew[[j-c]]=rbind(Bnew[[j-c]], c( B[[1+(c+1)]][[j-(c+1)]][k,], rep(0, ncol(Bnew[[j-c]])-n.H[[j-(c+1)]]) ) )
					     	 hapfreq[[j-c]]=c(hapfreq[[j-c]],0)
					  	   ca.hapfreq[[j-c]]=c(ca.hapfreq[[j-c]],0)
					  	   cn.hapfreq[[j-c]]=c(cn.hapfreq[[j-c]],0)
							 }					 
						 } else
						 
						 {
						   Bnew[[j-c]]=rbind(Bnew[[j-c]], c( B[[1+(c+1)]][[j-(c+1)]][k,], rep(0, ncol(Bnew[[j-c]])-n.H[[j-(c+1)]]) ) )
					     hapfreq[[j-c]]=c(hapfreq[[j-c]],0)
					  	 ca.hapfreq[[j-c]]=c(ca.hapfreq[[j-c]],0)
					  	 cn.hapfreq[[j-c]]=c(cn.hapfreq[[j-c]],0)		 
						 }
					}
				}
				
				if (j-c==1 & n.H[[1]]!=0) 
				{
					Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] )
					hapfreq[[1]]=c(hapfreq[[1]],0)
					ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
					cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)
        } 
				
				if (j-c==1 & n.H[[1]]==0 )
				{
					if (ncol(Bnew[[1]])+nrow(Bnew[[1]])==2)
					{  
					  if (Bnew[[1]]==0)
					  {
					    Bnew[[1]]=matrix(B1[[1+j]][k,],1,n.core)
					    hapfreq[[1]]=c(hapfreq[[1]])        
					    ca.hapfreq[[1]]=c(ca.hapfreq[[1]])   
					    cn.hapfreq[[1]]=c(cn.hapfreq[[1]])
					  } else
					  
					  {
					    Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] ) 
						  hapfreq[[1]]=c(hapfreq[[1]],0)
						  ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
						  cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)					  
					  }
					}	else 
					
					{
						Bnew[[1]]=rbind(Bnew[[1]], B1[[1+j]][k,] ) 
						hapfreq[[1]]=c(hapfreq[[1]],0)
						ca.hapfreq[[1]]=c(ca.hapfreq[[1]],0)
						cn.hapfreq[[1]]=c(cn.hapfreq[[1]],0)
					}					
				} 
			}
	   }
  	}
	 }	
	}
 }
}
##==================================================================================================
B.prod=matrix(0, n.core, n.core)
B.prod[row(B.prod)==col(B.prod)]=1
B.allocation=as.list(rep(0,H.max))
for(i in 1:H.max){
	B.allocation[[i]]=Bnew[[i]]%*%B.prod
	B.prod=as.matrix(B.allocation[[i]]) 
}
group.corefreq=corefreq
ca.group.corefreq=ca.corefreq
cn.group.corefreq=cn.corefreq
for (i in 1:H.max){
	group.corefreq=group.corefreq+hapfreq[[i]]%*%B.allocation[[i]]
	ca.group.corefreq=ca.group.corefreq+ca.hapfreq[[i]]%*%B.allocation[[i]]
	cn.group.corefreq=cn.group.corefreq+cn.hapfreq[[i]]%*%B.allocation[[i]]
}
##==================================================================================================
n.exp=nrow(hap.exp)
n.hapexp2core=matrix(1,n.exp,4)
for (i in 1:n.exp){
	for (j in 2:5){
		for (m in 1:H.max){
		 if (n.H[[m]]!=0){
			for (n in 1: n.H[[m]]){ 
				if (hap.exp[i,j]==H[[m]][n,n.col-1])
				{
					n.hapexp2core[i,j-1]=sum(ifelse(B.allocation[[m]][n,]==0,0,1)) 
				}
			 }	
			}
		}
	}
} 
n.recode.exp=matrix(0,n.exp,1)
for (i in 1:n.exp){
	n.recode.exp[i,1]=cumprod(n.hapexp2core[i,])[4]
}
n.total.recode.exp=sum(n.recode.exp) 
##==================================================================================================
n.people=nrow(fam.geno)
name.fam=as.numeric(levels(factor(fam.geno[,1])))
name.exp=as.numeric(levels(factor(hap.exp[,1])))
n.fam=length(name.fam)
n.name.exp=length(name.exp)
n.member=as.matrix(table(fam.geno[,1]))
child.data=fam.geno[fam.geno[,3]!=0,] 
n.child=as.matrix(table(child.data[,1]))
sumchild=sum(n.child)
if (sumchild>n.fam) { 
first.child=c(1,cumsum(n.child)+1) 
s.data=child.data[-c(first.child[1:n.fam]),]
name.s=as.numeric(levels(factor(s.data[,1])))
n.s=as.matrix(table(s.data[,1])) 
total.s=sum(n.s)
##==================================================================================================
snp=c(1,2) 
alldata=matrix(0,2^n.loci,n.loci)
for (i in 1:n.loci){
 alldata[,i]=rep(rep(snp, each=2^(n.loci-i)),time=2^(i-1))
}
##==================================================================================================
f.tr=matrix(0,n.exp,n.loci)
f.nontr=matrix(0,n.exp,n.loci)
m.tr=matrix(0,n.exp,n.loci)
m.nontr=matrix(0,n.exp,n.loci)
f.tr=alldata[hap.exp[,2]+1,] 
f.nontr=alldata[hap.exp[,3]+1,]
m.tr=alldata[hap.exp[,4]+1,]
m.nontr=alldata[hap.exp[,5]+1,]
geno1=f.tr+m.tr
geno2=f.tr+m.nontr
geno3=f.nontr+m.tr
geno4=f.nontr+m.nontr
s.marker=s.data[,7:(6+2*n.loci)]
s.geno=matrix(0,total.s,n.loci)
j=0
prod.s=matrix(1,n.exp,1)   

for (i in 1: n.loci){
	s.geno[,i]=s.marker[,i+j]+s.marker[,(i+1)+j]
	j=j+1
}

first.s.id=c(1,cumsum(n.s)+1)
s=as.list(rep(1,n.exp))
last.name.s=length(name.s)
last.fam=nrow(hap.exp)
while(name.s[last.name.s]!=hap.exp[last.fam,1])
{
	last.fam=last.fam-1
}                                            

i=1
j=1
while (i<= last.fam){
  if (hap.exp[i,1]>name.s[j])
 {
 	 j=j+1
 	 if (hap.exp[i,1]==name.s[j])
 	 {
 	 	s[[i]]=matrix(0,1,n.s[j]) 
 	 	for(k in 1: n.s[j]){
 	 	if (all(s.geno[first.s.id[j]+(k-1),]!=0))
 	  {
 	 	 s1=ifelse(sum(abs(geno1[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s2=ifelse(sum(abs(geno2[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s3=ifelse(sum(abs(geno3[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s4=ifelse(sum(abs(geno4[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s[[i]][k]=(sum(s1+s2+s3+s4))/4 	   
    }
    
    else
 	  {
 	  	s01=matrix(0,1,n.loci)
 	  	s02=matrix(0,1,n.loci)
 	  	s03=matrix(0,1,n.loci)
 	  	s04=matrix(0,1,n.loci)
 	  	 	  	
 	  	for (m in 1:n.loci){

 	  	 if ( s.geno[first.s.id[j]+(k-1),m]==0 )
 	  	 {
 	  	 	s01[1,m]=1
 	  	 	s02[1,m]=1
 	  	 	s03[1,m]=1
 	  	 	s04[1,m]=1 	  	 
 	  	 }
 	  	 else
 	  	 {
 	  	  s01[1,m]=ifelse((geno1[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)
 	  	 	s02[1,m]=ifelse((geno2[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)
 	  	 	s03[1,m]=ifelse((geno3[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)
 	  	 	s04[1,m]=ifelse((geno4[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)  	  
 	  	 }
 	  	s1=ifelse(sum(s01)/n.loci==1,1,0)
 	  	s2=ifelse(sum(s02)/n.loci==1,1,0)
 	  	s3=ifelse(sum(s03)/n.loci==1,1,0)
 	  	s4=ifelse(sum(s04)/n.loci==1,1,0)
 	  	s[[i]][k]=(sum(s1+s2+s3+s4))/4
 	  	  	 
 	  	}
 	  }
 	 }
  i=i+1 	 
 	} 
 	else 
 	{
 	  if (hap.exp[i,1]<name.s[j])
   {
     i=i+1 
   }
 	}
 }
 
else
{ 
 if (hap.exp[i,1]<name.s[j])
 {
   i=i+1 
 } 

 if (hap.exp[i,1]==name.s[j]) 
 {
 	 s[[i]]=matrix(0,1,n.s[j]) 
 	 for(k in 1: n.s[j]){
 	 	if (all(s.geno[first.s.id[j]+(k-1),]!=0))
 	  {
 	 	 s1=ifelse(sum(abs(geno1[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s2=ifelse(sum(abs(geno2[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s3=ifelse(sum(abs(geno3[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s4=ifelse(sum(abs(geno4[i,]-s.geno[first.s.id[j]+(k-1),]))==0,1,0)
 	   s[[i]][k]=(sum(s1+s2+s3+s4))/4 	   
    }
    else 
 	  {
 	  	s01=matrix(0,1,n.loci)
 	  	s02=matrix(0,1,n.loci)
 	  	s03=matrix(0,1,n.loci)
 	  	s04=matrix(0,1,n.loci)
 	  	 	  	
 	  	for (m in 1:n.loci){

 	  	 if ( s.geno[first.s.id[j]+(k-1),m]==0 )
 	  	 {
 	  	 	s01[1,m]=1
 	  	 	s02[1,m]=1
 	  	 	s03[1,m]=1
 	  	 	s04[1,m]=1 	  	 
 	  	 }
 	  	 else
 	  	 {
 	  	  s01[1,m]=ifelse((geno1[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)
 	  	 	s02[1,m]=ifelse((geno2[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)
 	  	 	s03[1,m]=ifelse((geno3[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)
 	  	 	s04[1,m]=ifelse((geno4[i,m]-s.geno[first.s.id[j]+(k-1),m])==0,1,0)  	  
 	  	 }
 	  	s1=ifelse(sum(s01)/n.loci==1,1,0)
 	  	s2=ifelse(sum(s02)/n.loci==1,1,0)
 	  	s3=ifelse(sum(s03)/n.loci==1,1,0)
 	  	s4=ifelse(sum(s04)/n.loci==1,1,0)
 	  	s[[i]][k]=(sum(s1+s2+s3+s4))/4
 	  	  	 
 	  	}
 	  }
 	 }
i=i+1
} 
}
}
for (i in 1:n.exp){
	prod.s[i,1]=prod(s[[i]]) 
}	 
}
##==================================================================================================
B.allocation.1=as.list(rep(0,H.max))
for(i in 1:H.max){
	B.allocation.1[[i]]=ifelse(B.allocation[[i]]!=0,1,NA) 
}

f.trans=as.list(hap.exp[,2])
f.nontrans=as.list(hap.exp[,3])
m.trans=as.list(hap.exp[,4])
m.nontrans=as.list(hap.exp[,5])

f.trans.freq=as.list(rep(1,n.exp)) 
f.nontrans.freq=as.list(rep(1,n.exp))
m.trans.freq=as.list(rep(1,n.exp))
m.nontrans.freq=as.list(rep(1,n.exp))

f.t.gcorefreq=as.list(rep(1,n.exp)) 
f.nt.gcorefreq=as.list(rep(1,n.exp))
m.t.gcorefreq=as.list(rep(1,n.exp))
m.nt.gcorefreq=as.list(rep(1,n.exp))

f.t.gcorefreq1=as.list(rep(1,n.exp))
f.nt.gcorefreq1=as.list(rep(1,n.exp))
m.t.gcorefreq1=as.list(rep(1,n.exp))
m.nt.gcorefreq1=as.list(rep(1,n.exp))

for (i in 1:n.exp){
	for (m in 1:H.max){
	 if (n.H[[m]]!=0){
		for (n in 1: n.H[[m]]){ 
				if (hap.exp[i,2]==H[[m]][n,n.col-1])
					{f.trans[[i]]=as.matrix(B.allocation.1[[m]][n,]*core.hap[,n.col-1])
					 f.trans.freq[[i]]=as.matrix(B.allocation.1[[m]][n,]*B.allocation[[m]][n,])
					 f.t.gcorefreq[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(group.corefreq))
					 f.t.gcorefreq1[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(ca.group.corefreq)) 
					 }
				
				if (hap.exp[i,3]==H[[m]][n,n.col-1])
					{f.nontrans[[i]]=as.matrix(B.allocation.1[[m]][n,]*core.hap[,n.col-1])
					 f.nontrans.freq[[i]]=as.matrix(B.allocation.1[[m]][n,]*B.allocation[[m]][n,])
					 f.nt.gcorefreq[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(group.corefreq))
					 f.nt.gcorefreq1[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(cn.group.corefreq))
					 }
				if (hap.exp[i,4]==H[[m]][n,n.col-1])
					{m.trans[[i]]=as.matrix(B.allocation.1[[m]][n,]*core.hap[,n.col-1])
					 m.trans.freq[[i]]=as.matrix(B.allocation.1[[m]][n,]*B.allocation[[m]][n,])
					 m.t.gcorefreq[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(group.corefreq))
					 m.t.gcorefreq1[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(ca.group.corefreq))
					 }
				if (hap.exp[i,5]==H[[m]][n,n.col-1])
					{m.nontrans[[i]]=as.matrix(B.allocation.1[[m]][n,]*core.hap[,n.col-1])
					 m.nontrans.freq[[i]]=as.matrix(B.allocation.1[[m]][n,]*B.allocation[[m]][n,])
					 m.nt.gcorefreq[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(group.corefreq))
					 m.nt.gcorefreq1[[i]]=as.matrix(B.allocation.1[[m]][n,]*c(cn.group.corefreq))
					 }
		}
	 }
	}
} 
for (i in 1:n.exp){
	for (m in 1:n.core){
				if (hap.exp[i,2]==core.hap[m,n.loci+1])
					{f.trans[[i]]=as.matrix(core.hap[,n.loci+1])
					 f.trans.freq[[i]]=as.matrix(1)
					 f.t.gcorefreq[[i]]=as.matrix(group.corefreq[m])
					 f.t.gcorefreq1[[i]]=as.matrix(ca.group.corefreq[m]) 
					 }
				
				if (hap.exp[i,3]==core.hap[m,n.loci+1])
					{f.nontrans[[i]]=as.matrix(core.hap[,n.loci+1])
					 f.nontrans.freq[[i]]=as.matrix(1)
					 f.nt.gcorefreq[[i]]=as.matrix(group.corefreq[m])
					 f.nt.gcorefreq1[[i]]=as.matrix(cn.group.corefreq[m])
					 }
				if (hap.exp[i,4]==core.hap[m,n.loci+1])
					{m.trans[[i]]=as.matrix(core.hap[,n.loci+1])
					 m.trans.freq[[i]]=as.matrix(1)
					 m.t.gcorefreq[[i]]=as.matrix(group.corefreq[m])
					 m.t.gcorefreq1[[i]]=as.matrix(ca.group.corefreq[m]) 
					 }
				if (hap.exp[i,5]==core.hap[m,n.loci+1])
					{m.nontrans[[i]]=as.matrix(core.hap[,n.loci+1])
					 m.nontrans.freq[[i]]=as.matrix(1)
					 m.nt.gcorefreq[[i]]=as.matrix(group.corefreq[m])
					 m.nt.gcorefreq1[[i]]=as.matrix(cn.group.corefreq[m])
					 }
	}
} 
##==================================================================================================
f.trans.NAomit=as.list(rep(0,n.exp))
f.nontrans.NAomit=as.list(rep(0,n.exp))
m.trans.NAomit=as.list(rep(0,n.exp))
m.nontrans.NAomit=as.list(rep(0,n.exp))

f.t.freq.NAomit=as.list(rep(0,n.exp))
f.nt.freq.NAomit=as.list(rep(0,n.exp))
m.t.freq.NAomit=as.list(rep(0,n.exp))
m.nt.freq.NAomit=as.list(rep(0,n.exp))

f.t.gcfreq.NAomit=as.list(rep(0,n.exp))
f.nt.gcfreq.NAomit=as.list(rep(0,n.exp))
m.t.gcfreq.NAomit=as.list(rep(0,n.exp))
m.nt.gcfreq.NAomit=as.list(rep(0,n.exp))

f.t.gcfreq.NAomit1=as.list(rep(0,n.exp))
f.nt.gcfreq.NAomit1=as.list(rep(0,n.exp))
m.t.gcfreq.NAomit1=as.list(rep(0,n.exp))
m.nt.gcfreq.NAomit1=as.list(rep(0,n.exp))

for (i in 1:n.exp){
 f.trans.NAomit[[i]]=as.matrix(na.omit(f.trans[[i]]))
 f.nontrans.NAomit[[i]]=as.matrix(na.omit(f.nontrans[[i]]))
 m.trans.NAomit[[i]]=as.matrix(na.omit(m.trans[[i]]))
 m.nontrans.NAomit[[i]]=as.matrix(na.omit(m.nontrans[[i]]))
 f.t.freq.NAomit[[i]]=as.matrix(na.omit(f.trans.freq[[i]]))
 f.nt.freq.NAomit[[i]]=as.matrix(na.omit(f.nontrans.freq[[i]]))
 m.t.freq.NAomit[[i]]=as.matrix(na.omit(m.trans.freq[[i]]))
 m.nt.freq.NAomit[[i]]=as.matrix(na.omit(m.nontrans.freq[[i]]))
 
 f.t.gcfreq.NAomit[[i]]=as.matrix(na.omit(f.t.gcorefreq[[i]]))
 f.nt.gcfreq.NAomit[[i]]=as.matrix(na.omit(f.nt.gcorefreq[[i]]))
 m.t.gcfreq.NAomit[[i]]=as.matrix(na.omit(m.t.gcorefreq[[i]]))
 m.nt.gcfreq.NAomit[[i]]=as.matrix(na.omit(m.nt.gcorefreq[[i]]))
 
 f.t.gcfreq.NAomit1[[i]]=as.matrix(na.omit(f.t.gcorefreq1[[i]]))  
 f.nt.gcfreq.NAomit1[[i]]=as.matrix(na.omit(f.nt.gcorefreq1[[i]]))
 m.t.gcfreq.NAomit1[[i]]=as.matrix(na.omit(m.t.gcorefreq1[[i]]))  
 m.nt.gcfreq.NAomit1[[i]]=as.matrix(na.omit(m.nt.gcorefreq1[[i]]))
} 
##==================================================================================================
g.hap.exp=list()
for (i in 1:n.exp){ 
 g.hap.exp[[i]]=matrix(0,n.recode.exp[i],23)
 m=1
 	for (j1 in 1:n.hapexp2core[i,1]){
 		for (j2 in 1:n.hapexp2core[i,2]){
 	 		for (j3 in 1:n.hapexp2core[i,3]){
 	 			for (j4 in 1:n.hapexp2core[i,4]){
 	 	
 	 				g.hap.exp[[i]][m,1]=f.trans.NAomit[[i]][j1,1]     
 	 				g.hap.exp[[i]][m,2]=f.nontrans.NAomit[[i]][j2,1]  
 	 				g.hap.exp[[i]][m,3]=m.trans.NAomit[[i]][j3,1]     
 	 				g.hap.exp[[i]][m,4]=m.nontrans.NAomit[[i]][j4,1]  
 	 				
 	 				g.hap.exp[[i]][m,5]=f.t.freq.NAomit[[i]][j1,1]    
 	 				g.hap.exp[[i]][m,6]=f.nt.freq.NAomit[[i]][j2,1]   
 	 				g.hap.exp[[i]][m,7]=m.t.freq.NAomit[[i]][j3,1]    
 	 				g.hap.exp[[i]][m,8]=m.nt.freq.NAomit[[i]][j4,1]   
 	 				
 	 				g.hap.exp[[i]][m,9]=g.hap.exp[[i]][m,5]*g.hap.exp[[i]][m,6]*g.hap.exp[[i]][m,7]*g.hap.exp[[i]][m,8] 
 	 				
 	 				g.hap.exp[[i]][m,10]=hap.exp[i,6] 
 	 					 				
 	 				g.hap.exp[[i]][m,11]=g.hap.exp[[i]][m,9]*g.hap.exp[[i]][m,10]
 	 				
 	 				g.hap.exp[[i]][m,12]= f.t.gcfreq.NAomit[[i]][j1,1]   
 	 				g.hap.exp[[i]][m,13]= f.nt.gcfreq.NAomit[[i]][j2,1]  
 	 				g.hap.exp[[i]][m,14]= m.t.gcfreq.NAomit[[i]][j3,1]   
 	 				g.hap.exp[[i]][m,15]= m.nt.gcfreq.NAomit[[i]][j4,1]  
 	 				g.hap.exp[[i]][m,16]=prod.s[[i]]
 	 				#g.hap.exp[[i]][m,16]=1 #trio S=1
 	 				g.hap.exp[[i]][m,17]=g.hap.exp[[i]][m,12]*g.hap.exp[[i]][m,13]*g.hap.exp[[i]][m,14]*g.hap.exp[[i]][m,15]*g.hap.exp[[i]][m,16]*g.hap.exp[[i]][m,9]
 	 				g.hap.exp[[i]][m,18]=f.t.gcfreq.NAomit1[[i]][j1,1]  
 	 				g.hap.exp[[i]][m,19]=f.nt.gcfreq.NAomit1[[i]][j2,1] 
 	 				g.hap.exp[[i]][m,20]=m.t.gcfreq.NAomit1[[i]][j3,1]  
 	 				g.hap.exp[[i]][m,21]=m.nt.gcfreq.NAomit1[[i]][j4,1] 
 	 				g.hap.exp[[i]][m,22]=g.hap.exp[[i]][m,18]*g.hap.exp[[i]][m,19]*g.hap.exp[[i]][m,20]*g.hap.exp[[i]][m,21]*g.hap.exp[[i]][m,16]*g.hap.exp[[i]][m,9]
 	 				g.hap.exp[[i]][m,23]=hap.exp1[i,6] 
 	 				m=m+1
 	 				
 	 			}
 	 		}
 		} 
 	}
} 
gcorefreq.s=matrix(0,n.exp,1)
H1.gcorefreq.s=matrix(0,n.exp,1)

for (i in 1:n.exp){
	gcorefreq.s[i]=sum(g.hap.exp[[i]][,17])
	H1.gcorefreq.s[i]=sum(g.hap.exp[[i]][,22])
}
##==================================================================================================
fam.exp.no=as.matrix(table(hap.exp[,1])) 
first.id=c(1,cumsum(fam.exp.no)+1)
group.sum.freq.s=matrix(0,n.name.exp,1)
group.H1.sum.freq.s=matrix(0,n.name.exp,1)

for (i in 1:n.name.exp){
		group.sum.freq.s[i,1]=sum(gcorefreq.s[first.id[i]:(first.id[i]+fam.exp.no[i]-1),1])
		group.H1.sum.freq.s[i,1]=sum(H1.gcorefreq.s[first.id[i]:(first.id[i]+fam.exp.no[i]-1),1])
}

g.likeli=sum(log(group.sum.freq.s))
H1.g.likeli=sum(log(group.H1.sum.freq.s))
##==================================================================================================
group.stat=2*(H1.g.likeli-g.likeli)
group.cp=qchisq(0.95, n.core-1, ncp=0, lower.tail = TRUE, log.p = FALSE)
df=n.core-1
cat("testing statistics = ",group.stat,"\n")
cat("critical value = ",group.cp,"\n")
cat("df = ",df,"\n")

if( group.stat > group.cp ) {
	cat("Result:reject Ho \n") 
} else {
	cat("Result:not reject Ho \n")
}
  } 
 } 
}
